#include <iostream>
#include <iomanip>
#include <string>

using namespace std;

bool contains(string s, string characters);
string DeobfuscateCharacters(string s);

int main()
{
	char c = 'c';			//user input character
	string s;		//user input string
	string pauser = "pauser";	//"unused"

	string obfuscateCharacters = "|$10-";  //characters checked for obfuscation
	string spamWord = "viagra";			   //string is considered spam if it contains this string

	string notSpamSentance = "not spam $sentance";	//initial not spam sentance to check
	string spamSentance = "buy v1agra t10day!";								//initial spam sentance to check

	//checks non spam sentance and deobfuscates it
	if (contains(notSpamSentance, obfuscateCharacters))
	{
		//there are obfuscate characters
		notSpamSentance = DeobfuscateCharacters(notSpamSentance);
	}

	//checks spam sentances and deobfuscates it
	if (contains(spamSentance, obfuscateCharacters))
	{
		//there are obfuscate characters
		spamSentance = DeobfuscateCharacters(spamSentance);
	}

	//checks non spam sentance for spam word
	if (notSpamSentance.find(spamWord) == -1)
	{
		cout << "Sentance '" + notSpamSentance + "' is not a spam sentance\n";
	}

	else
	{
		cout << "Sentance '" + notSpamSentance + "' is a spam sentance\n";
	}
	
	//checks spam sentance for spam word
	if (spamSentance.find(spamWord) == -1)
	{
		cout << "Sentance '" + spamSentance + "' is not spam sentance\n";
	}

	else
	{
		cout << "Sentance '" + spamSentance + "' is a spam sentance\n";
	}

	//ask user to try their own sentance
	cout << "\n\nWould you like to try your own obfuscation? Enter 'y' for yes and 'n' for no. \n\nCharacters checked are |, $, 1, 0, and -. \nSentance considered spam if the deobfuscated sentance contains the word viagra\n\n";
	cin >> c;

	//ensures the user only enters y or n
	while (c != 'y' && c != 'n')
	{
		cout <<"\nPlease only enter 'y' or 'n'\n";
		cin >> c;
	}

	//allows the user to check their own spam sentance
	if (c == 'y')
	{
		cout << "\nEnter a full sentance followed by the enter/return key:\n";
		cin >> s;

		//if the users sentance contains obfuscated characters, deobfuscate the sentance
		if (contains(s, obfuscateCharacters))
		{
			//there are obfuscate characters
			s = DeobfuscateCharacters(s);
		}

		//if the deobfuscated user sentance contains the spam word, tell the user
		if (s.find(spamWord) == -1)
		{
			cout << "Sentance '" + s + "' is not a spam sentance\n";
		}

		else
		{
			cout << "Sentance '" + s + "' is a spam sentance\n";
		}

		//final goodbye
		cout <<"Thank you for using the deobfuscator! have a nice day!\n";

		cin >> pauser;
	}

	if (c == 'n')
	{
		//final goodbyte
		cout << "thank you for using the deobfuscator!";
		return 0;
	}
}

//checks the string for obfuscated characters
bool contains(string s, string characters)
{
	bool doesContain = false;

	for(int i = 0; i < s.size(); i++)
	{
		for (int j = 0; j < characters.size(); j++)
		{
			if (s[i] == characters[j])
			{
				doesContain = true;
			}
		}
	}
	return doesContain;
}

//deobfuscates characters
string DeobfuscateCharacters(string s)
{
	for (int i = 0; i < s.size(); i++)
	{
		if (s[i] == '|')
			s[i] = 'i';

		if (s[i] == '$')
			s[i] = 's';

		if (s[i] == '1')
			s[i] = 'i';

		if (s[i] == '0')
			s[i] = 'o';

		if (s[i] == '-')
		{
			for (int j = i; j < s.size(); j++)
			{
				s[j] = s[j + 1];
			}
			s.erase(s.begin() + s.size());
		}
	}
	
	return s;
}
